//---------------------------------------------------------------------------

#include <vcl.h>
#include <io.h>
#pragma hdrstop

#include "simplex.h"
#include "main_form.h"
#include "About.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
SimplexIteration smx;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  smx_run();
}

//--------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	Application->Terminate();
}

//---------------------------------------------------------------------------

void smx_input(char *file)
{
  try { smx=SimplexIteration(file); }
  catch(SimplexIteration::bad_simplex &e)
  { Application->MessageBox("   !!!","SMX",MB_OK);
             for (int i=0;i<=e;i++)
                 Application->MessageBox(e.text_err(i),"  ",MB_OK);
             Form1->Button1->Enabled=false;
             return;
  }

  if (smx.Get_NoTable()) Form1->RadioButton6->Checked=true;
  else if (smx.Get_OnlyOptimalTable() && smx.Get_OnlyDataTable())
     Form1->RadioButton4->Checked=true;
  else if (smx.Get_OnlyOptimalTable()) Form1->RadioButton3->Checked=true;
  else if (smx.Get_OnlyDataTable()) Form1->RadioButton2->Checked=true;
  else if ( smx.Get_Start_Iter() && smx.Get_End_Iter() )
        { Form1->Edit2->Enabled=true;
          Form1->Edit3->Enabled=true;
          Form1->RadioButton5->Checked=true;
          Form1->Edit2->Text=String(smx.Get_Start_Iter());
          Form1->Edit3->Text=String(smx.Get_End_Iter());
        }

  Form1->Edit4->Text=String(smx.GetWidth());
  Form1->Edit5->Text=String(smx.GetPrecision());
  Form1->Edit4->Enabled=true;
  Form1->Edit5->Enabled=true;

  // Application->MessageBox("     !", "", MB_OK);
  Form1->Button1->Enabled=true;
}

//---------------------------------------------------------------------------

void smx_run()
{
//   

  if (Form1->RadioButton6->Checked==true) smx.Put_NoTable(1);
  else smx.Put_NoTable(0);

  if (Form1->RadioButton3->Checked==true) smx.Put_OnlyOptimalTable(1);
  else  smx.Put_OnlyOptimalTable(0);

  if (Form1->RadioButton2->Checked==true) smx.Put_OnlyDataTable(1);
  else smx.Put_OnlyDataTable(0);

  if (Form1->RadioButton4->Checked==true)
     { smx.Put_OnlyOptimalTable(1); smx.Put_OnlyDataTable(1); }

  if (Form1->RadioButton5->Checked==true)
     { int a=atoi(Form1->Edit2->Text.c_str()), b=atoi(Form1->Edit3->Text.c_str());
       if (b<a || b<0)
          {
            Application->MessageBox("   !","  ",MB_OK);
            Form1->Edit2->Text=String(smx.Get_Start_Iter());
            Form1->Edit3->Text=String(smx.Get_End_Iter());
            return;
          }
       else { smx.Put_Start_Iter(a); smx.Put_End_Iter(b); }
     }
  else { smx.Put_Start_Iter(0); smx.Put_End_Iter(0); }

  int a=atoi(Form1->Edit4->Text.c_str()), b=atoi(Form1->Edit5->Text.c_str());
  if (b>=a || b<0)
     {
       Application->MessageBox("   !","  ",MB_OK);
       Form1->Edit4->Text=String(smx.GetWidth());
       Form1->Edit5->Text=String(smx.GetPrecision());
       return;
     }
  else { smx.NewWidth(a); smx.NewPrecision(b); }

//---------------------------------------------------------------

  Matrix::field(smx.GetWidth(),smx.GetPrecision());

  Form1->Label1->Caption=":";
  Form1->Label2->Caption="0";

  try { Matrix v=!(simplexMethod(smx)); }
  catch(SimplexIteration::bad_simplex &e)
  { for (int i=0;i<=e;i++)
    Application->MessageBox(e.text_err(i),"  ",MB_OK);
    return;
  }
  Application->MessageBox(" !", "SMX", MB_OK);
  Form1->Label1->Caption="";
  Form1->Label2->Caption="";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
        Application-> CreateForm(__classid(TForm2),&Form2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileOpenItemClick(TObject *Sender)
{
	if (OpenDialog1->Execute())
           Edit1->Text=OpenDialog1->FileName;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton5Click(TObject *Sender)
{
        Form1->Edit2->Enabled=true;
        Form1->Edit3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
        Form1->Edit2->Enabled=false;
        Form1->Edit3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
        Form1->Edit2->Enabled=false;
        Form1->Edit3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
        Form1->Edit2->Enabled=false;
        Form1->Edit3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{
        Form1->Edit2->Enabled=false;
        Form1->Edit3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton6Click(TObject *Sender)
{
        Form1->Edit2->Enabled=false;
        Form1->Edit3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if (Edit1->Text==AnsiString("*.smx"))
       { Application->MessageBox("    !", "  ", MB_OK);
       Button1->Enabled=false; return;
       }
  if (access(Edit1->Text.c_str(),0))
     { Application->MessageBox("  !", "  ", MB_OK);
       Button1->Enabled=false; return;
     }
  Form1->RadioButton1->Checked=true;
  smx_input(Edit1->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1DblClick(TObject *Sender)
{
     if (OpenDialog1->Execute())
        Edit1->Text=OpenDialog1->FileName;
}
//---------------------------------------------------------------------------

